=== debian/changelog ===
tiledb (2.12.1-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 04 Nov 2022 15:27:16 -0500

tiledb (2.12.0-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 20 Oct 2022 22:11:21 -0500

tiledb (2.11.99-2) unstable; urgency=medium

  * Rebuild and source-only re-upload following NEW queue passage

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 19 Oct 2022 08:49:01 -0500

tiledb (2.11.99-1) unstable; urgency=medium

  * New upstream (pre-) release of 2.12.0
  * debian/control: Adjust to libtiledb2.12
  * libtiledb2.12.dirs: Idem
  * libtiledb2.12.install: Idem
  
 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 18 Oct 2022 20:19:59 -0500
