## tiledb 2.12.2

=== debian/changelog ===
tiledb (2.12.2-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 11 Nov 2022 10:27:13 -0600
